#include "paramSimul.h"
#include "ue.h"
#include "objectBSSectorUe.h"
#include <algorithm> 
#include <stdio.h>
#include <iostream>
#include <fstream>

using namespace std;

void Connect_UE_BS(void)
{
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		double *temp_LS_gain;
		temp_LS_gain = new double[num_sector];

		for (int sec_idx = 0; sec_idx < num_sector; sec_idx++)
		{
			int bs_idx = sec_idx / (num_sector / num_bs);

			ue[ue_idx].LS_gain[sec_idx] = -(ue[ue_idx].pathloss[bs_idx] + ue[ue_idx].LSPs[bs_idx](0)) + ue[ue_idx].antennagain[sec_idx];
			temp_LS_gain[sec_idx] = -(ue[ue_idx].pathloss[bs_idx] + ue[ue_idx].LSPs[bs_idx](0)) + ue[ue_idx].antennagain[sec_idx];
		}
		sort(temp_LS_gain, temp_LS_gain + num_sector);


		for (int sec_idx = 0; sec_idx < num_sector; sec_idx++)
		{
			for (int idx = 0; idx < num_compute_coef; idx++)
			{
				if (temp_LS_gain[num_sector - idx - 1] == ue[ue_idx].LS_gain[sec_idx])
				{
					ue[ue_idx].adj_sector[idx] = sec_idx;
				}
			}
		}
		ue[ue_idx].sector_in_control = ue[ue_idx].adj_sector[0];

		//cout << "ue_idx : " << ue_idx << endl;
		//cout << "ue[ue_idx].sector_in_control : " << ue[ue_idx].sector_in_control << endl;

		sector[ue[ue_idx].sector_in_control].ue_in_control.push_back(ue_idx);


	}

	/*
	for ( int sec_idx = 0; sec_idx<num_sector; sec_idx++)
	{
		cout << "sec_idx : " << sec_idx << endl;
		cout << "size : " << sector[sec_idx].ue_in_control.size() << endl;
		for (int i = 0; i< int(sector[sec_idx].ue_in_control.size()); i++)
		{
			cout << sector[sec_idx].ue_in_control[i] << "  ";
		}
		cout << endl;
	}
	
	cout << endl;
	getchar();
	*/
}